/*
Annual Spring Contest in Collegiate Programming
at Poznan University of Technology
26 May 2001

Judge's Checking Program

Problem: Mock B (Szachownica)
Author : Piotr Zielinski
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

const N=600;

int hashx[N];
int hashy[N];
int hashxy[N+N];

void inithash(void) {
	randomize();
	for(int i=0;i<N;i++)
		hashx[i] = random(10000);
	for(i=0;i<N;i++)
		hashy[i] = random(10000);
	for(i=0;i<N;i++)
		hashxy[i] = random(10000);
}

int hash(int x, int y) {
	return hashx[x] + hashy[y] + hashxy[x+y];
}

int Check(FILE *fin, FILE *fout) {
	int n,m;
	fscanf(fin,"%i %i", &n, &m);

	if (n%2==1 && m%2==1) {
		char buffer[100];
		fscanf(fout, "%50s", buffer);
		strupr(buffer);
		return !strcmp(buffer, "NIE");
	}

	int prevx=0, prevy=1;
	int sum = 0;
	int expsum = 0;

	for(int x=1;x<=n;x++)
		for(int y=1;y<=m;y++)
			expsum += hash(x,y);
	expsum+=hash(1,1);


	for(long i=0;i<=long(m)*long(n);i++) {
		int x,y;
		if (fscanf(fout, "%i %i", &x, &y) < 2) return 0;
		if (x<=0 || x>n || y<=0 || y>m) return 0;
		if (abs(x-prevx) + abs(y-prevy) != 1) return 0;
		sum += hash(x,y);
		prevx=x;prevy=y;
	}

	if (prevx != 1 || prevx != 1) return 0;
	if (sum != expsum) return 0;
	return 1;
}

int main(void) {
	FILE *fin = fopen("b.in","r");
	FILE *fout = fopen("b.out","r");

	inithash();

	int d;

	fscanf(fin,"%i", &d);

	for(int i=0;i<d;i++)
		if (!Check(fin, fout)) return 1;

	printf("OK!\n");
	return 0;
}


